"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.OptInMessage = void 0;

var React = _interopRequireWildcard(require("react"));

var _eui = require("@elastic/eui");

var _react2 = require("@kbn/i18n/react");

var _opt_in_details_component = require("./opt_in_details_component");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var OptInMessage =
/*#__PURE__*/
function (_React$PureComponent) {
  _inherits(OptInMessage, _React$PureComponent);

  function OptInMessage() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, OptInMessage);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(OptInMessage)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      showDetails: false,
      showExample: false
    });

    _defineProperty(_assertThisInitialized(_this), "toggleShowExample", function () {
      _this.setState(function (prevState) {
        return {
          showExample: !prevState.showExample
        };
      });
    });

    return _this;
  }

  _createClass(OptInMessage, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var fetchTelemetry = this.props.fetchTelemetry;
      var _this$state = this.state,
          showDetails = _this$state.showDetails,
          showExample = _this$state.showExample;

      var getDetails = function getDetails() {
        return React.createElement(_react2.FormattedMessage, {
          id: "kbn.home.telemetry.optInMessage.detailsDescription",
          defaultMessage: "No information about the data you process or store will be sent. This feature will periodically send basic feature usage statistics. See an {exampleLink} or read our {telemetryPrivacyStatementLink}. You can disable this feature at any time.",
          values: {
            exampleLink: React.createElement(_eui.EuiLink, {
              onClick: _this2.toggleShowExample
            }, React.createElement(_react2.FormattedMessage, {
              id: "kbn.home.telemetry.optInMessage.detailsExampleLinkText",
              defaultMessage: "example"
            })),
            telemetryPrivacyStatementLink: React.createElement(_eui.EuiLink, {
              href: "https://www.elastic.co/legal/telemetry-privacy-statement",
              target: "_blank"
            }, React.createElement(_react2.FormattedMessage, {
              id: "kbn.home.telemetry.optInMessage.detailsTelemetryPrivacyStatementLinkText",
              defaultMessage: "telemetry privacy statement"
            }))
          }
        });
      };

      var getFlyoutDetails = function getFlyoutDetails() {
        return React.createElement(_opt_in_details_component.OptInExampleFlyout, {
          onClose: function onClose() {
            return _this2.setState({
              showExample: false
            });
          },
          fetchTelemetry: fetchTelemetry
        });
      };

      var getReadMore = function getReadMore() {
        return React.createElement(_eui.EuiLink, {
          onClick: function onClick() {
            return _this2.setState({
              showDetails: true
            });
          }
        }, React.createElement(_react2.FormattedMessage, {
          id: "kbn.home.telemetry.optInMessage.readMoreLinkText",
          defaultMessage: "Read more"
        }));
      };

      return React.createElement(React.Fragment, null, React.createElement(_react2.FormattedMessage, {
        id: "kbn.home.telemetry.optInMessageDescription",
        defaultMessage: "Help us improve the Elastic Stack by providing usage statistics for basic features. We will not share this data outside of Elastic."
      }), ' ', !showDetails && getReadMore(), showDetails && getDetails(), showDetails && showExample && getFlyoutDetails());
    }
  }]);

  return OptInMessage;
}(React.PureComponent);

exports.OptInMessage = OptInMessage;